#include "cyc_cnt.h"

/**
 * @brief read cycle counter
 * @return cycle counter value
 */
unsigned int cyc_cnt_read(void)
{
  volatile unsigned int *p_cyc_cnt = (volatile unsigned int *)0x80001000;
  return *p_cyc_cnt;
}

/**
 * @brief delay for a number of cycles
 * @param[in] cyc number of cycles
 */
void cyc_cnt_delay(unsigned int cyc)
{
  unsigned int start = cyc_cnt_read();
  while (cyc_cnt_read() - start < cyc)
    /* wait */;
}

/**
 * @brief delay for a number of microseconds
 * @param[in] us number of microseconds
 */
void cyc_cnt_delay_us(unsigned int us)
{
  cyc_cnt_delay(us * 50);
}

/**
 * @brief delay for a number of milliseconds
 * @param[in] ms number of milliseconds
 */
void cyc_cnt_delay_ms(unsigned int ms)
{
  cyc_cnt_delay_us(ms * 1000);
}

